/// <reference types="node" />
import { EventEmitter } from 'events';
/**Refer to RWMutex in Golang */
export declare class RWMutex extends EventEmitter {
    private _rlocks;
    private _wlocked;
    private _lockQueue;
    state: 'LOCKED' | 'RLOCKED' | 'UNLOCKED';
    constructor();
    private _releaseLocks;
    private _enqueueLockAndWait;
    writeLength(): number;
    hasNextWrites(): boolean;
    hasNextRead(): boolean;
    /**
     * @deprecated use .rLock()
     */
    RLock(): Promise<void>;
    /**Acquire Read Lock. Use it for thread-safe operations */
    rLock(): Promise<void>;
    /**
     * @deprecated use .lock()
     */
    Lock(): Promise<void>;
    /**Acquire Write Lock. Use it for operations that require monopoly resource usage */
    lock(): Promise<void>;
    /**
     * @deprecated use .rUnlock()
     */
    RUnlock(): void;
    /**Release Read Lock */
    rUnlock(): void;
    /**
     * @deprecated use .unlock()
     */
    Unlock(): void;
    /**Release Write Lock */
    unlock(): void;
}
export declare function runWithMutexR<T>(mx: RWMutex, fnc: (...args: any[]) => Promise<T>): Promise<T>;
export declare function runWithMutexW<T>(mx: RWMutex, fnc: (...args: any) => Promise<T>): Promise<T>;
